<script lang="ts" setup>
import type { ExtendedModalApi } from '@vben/common-ui';

import type { VbenFormSchema } from '#/adapter/form';
import type { EmployeeInfoApi } from '#/api/hr/employeeModel';

import { computed, ref, shallowRef } from 'vue';

import { useVbenModal } from '@vben/common-ui';
import { getVxePopupContainer } from '@vben/utils';

import { Button } from 'ant-design-vue';

import { useVbenForm } from '#/adapter/form';
import { apiDetail } from '#/api/hr/employeeFlow';
import { applyResign } from '#/api/hr/employeeInfo';
import { getDictOptions } from '#/utils/dict';
import { defaultFormValueGetter, useBeforeCloseDiff } from '#/utils/popup';

import { HrDictEnum } from '../dict-enum';
import { useHrFlowHook } from '../useHrFlowHook';

const emit = defineEmits<{
  success: [];
}>();
const isUpdate = ref(false);

const formSchema: VbenFormSchema[] = [
  {
    label: '主键',
    fieldName: 'id',
    component: 'Input',
    dependencies: {
      show: () => false,
      triggerFields: [''],
    },
  },
  {
    label: '员工id',
    fieldName: 'employeeId',
    component: 'Input',
    dependencies: {
      show: () => false,
      triggerFields: [''],
    },
  },
  {
    component: 'Input',
    fieldName: 'applyCode',
    label: '申请编号',
    dependencies: {
      show: () => false,
      triggerFields: [''],
    },
    disabled: true,
  },
  {
    component: 'Input',
    fieldName: 'name',
    label: '姓名',
    disabled: true,
  },
  {
    component: 'Input',
    fieldName: 'deptName',
    label: '部门',
    disabled: true,
  },
  {
    component: 'Select',
    componentProps: {
      options: getDictOptions(HrDictEnum.HR_RESIGNATION_TYPE),
      getVxePopupContainer,
    },
    fieldName: 'resignationType',
    defaultValue: '1',
    label: '离职类型',
    rules: 'required',
  },
  {
    component: 'DatePicker',
    componentProps: {
      format: 'YYYY-MM-DD',
      valueFormat: 'YYYY-MM-DD',
      getVxePopupContainer,
    },
    fieldName: 'resignationDate',
    label: '离职日期',
    rules: 'required',
  },
  {
    component: 'Select',
    componentProps: {
      options: getDictOptions(HrDictEnum.HR_RESIGNATION_CATEGORY),
      getVxePopupContainer,
    },
    fieldName: 'resignationCategory',
    label: '离职类别',
    rules: 'required',
  },
  {
    component: 'Input',
    fieldName: 'resignationReason',
    label: '离职原因',
    // rules: 'required',
  },
  {
    component: 'DatePicker',
    componentProps: {
      format: 'YYYY-MM-DD',
      valueFormat: 'YYYY-MM-DD',
      getVxePopupContainer,
    },
    fieldName: 'finalPayDate',
    label: '最后结薪日',
    // rules: 'required',
  },
  // {
  //   component: 'Input',
  //   fieldName: 'description',
  //   label: '描述',
  //   rules: 'required',
  // },
  {
    component: 'Textarea',
    fieldName: 'remark',
    label: '离职申请备注',
    formItemClass: 'items-start',
  },
];
const applyModalApi = shallowRef<ExtendedModalApi | null>(null);

const [BasicForm, formApi] = useVbenForm({
  commonConfig: {
    componentProps: {
      class: 'w-full',
    },
    formItemClass: 'col-span-2',
    labelWidth: 90,
  },
  schema: formSchema,
  showDefaultActions: false,
  wrapperClass: 'grid-cols-2',
});

const { onBeforeClose, markInitialized, resetInitialized } = useBeforeCloseDiff(
  {
    initializedGetter: defaultFormValueGetter(formApi),
    currentGetter: defaultFormValueGetter(formApi),
  },
);

const [BasicModal, modalApi] = useVbenModal({
  fullscreenButton: false,
  onBeforeClose,
  onClosed: handleClosed,
  onConfirm: onSubmit,
  confirmText: '提交申请',
  onOpenChange: async (isOpen) => {
    if (!isOpen) {
      return null;
    }
    modalApi.modalLoading(true);

    let data = modalApi.getData() as EmployeeInfoApi.EmployeeResignApplyBo & {
      applyModalApi: ExtendedModalApi;
    };
    applyModalApi.value = data.applyModalApi;
    isUpdate.value = !!data?.id;
    if (isUpdate.value && data.id) {
      updateForm(isUpdate.value);
      data = await apiDetail(data.id);
      updateDataInfo(data);
    }
    await formApi.setValues(data);
    await markInitialized();

    modalApi.modalLoading(false);
  },
});

const { handleTempSave, onSubmitFunc, updateDataInfo, updateForm } =
  useHrFlowHook(formApi, modalApi, applyResign, () => {
    resetInitialized();
    emit('success');
  });

function onSubmit() {
  onSubmitFunc(applyModalApi.value);
}
// function updateDataInfo(data: EmployeeInfoApi.EmployeeApplyBaseBo) {
//   if (data.auditLogList && data.auditLogList.length > 0) {
//     data.auditLogList.map((t) => {
//       if (t && t.auditField) {
//         (data as any)[mapDict[t.auditField]!] = t.afterVal;
//       }
//       return t;
//     });
//   }
// }

// function updateForm(update: boolean) {
//   formApi.updateSchema([
//     {
//       dependencies: {
//         show: () => update,
//         triggerFields: [''],
//       },
//       fieldName: 'applyCode',
//     },
//   ]);
// }

// async function onSubmit() {
//   const { valid } = await formApi.validate();
//   if (valid) {
//     modalApi.lock();
//     const data =
//       await formApi.getValues<EmployeeInfoApi.EmployeeResignApplyBo>();
//     try {
//       await applyResign(data);
//       resetInitialized();
//       emit('success');
//       modalApi.close();
//     } finally {
//       modalApi.unlock();
//     }
//   }
// }

async function handleClosed() {
  await formApi.resetForm();
  resetInitialized();
}

const getModalTitle = computed(() =>
  isUpdate.value ? '修改离职申请' : '离职申请',
);
</script>
<template>
  <BasicModal :title="getModalTitle">
    <BasicForm class="mx-4" />
    <template #center-footer>
      <Button @click="handleTempSave">暂存</Button>
    </template>
  </BasicModal>
</template>
